      PROGRAM INTP
C
C  THIS PROGRAM GENERATES THREE FILES THAT CAN BE MERGED
C  IN ANY KINETIC ROUTINE CURRENTLY USED IN THE HP SYSTEM.
C  IT ALSO GENERATES THE ROUTINE'S DATA FILE.
C  ITS INPUT ARE:
C
C     DABA.LIB : data base
C     REAC.INP : FILE USER CREATES TO SPECIFY HIS MECHANISM
C
C     DABA.LIB description:
C
C	CARD #	    VARIABLE(s) 			   FORMAT
C
C	  1	# OF SELECT.SPECIES			     FREE
C
C	  2	  SPECIES NAME				     A4
C
C	  3	  AK,XK,EK,mol.weight			     FREE
C		  I
C	     for the description of these,
C	     see the main kinetic program
C
C	  4	  EN(6) 				     FREE
C		   I
C	     1st 6 coeff.of the Nasa fit
C	     of Janaf thermo. data
C	     (used for temp. calc.)
C
C	 REPEAT CARDS 2 TO 4
C
C	  5	   # OF REACTIONS IN LIBRARY			  FREE
C
C	  6  rxt type,rate cst coeff A,B&E, direction of rxt	  FREE
C			 I			 I
C		   k=A*T**B*exp(-E/RT)	       1=>forwards
C					       2=>backwards
C
C	  7	reaction formula			       see below
C
C	  8	source for the rate constant			13A2
C
C	  REPEAT CARDS 5 TO 8
C
C     REAC.INP description:
C
C	CARD #		     PARAMETER(s)		       FORMAT
C
C	  1	    # of species,# of rxts			 free
C
C	  2	      species name				 A4
C
C	      repeat card 2.The order determines
C	      the species index in the kinetic
C	      routine
C
C	  3	       reaction type				  free
C
C	  4	       reaction formula 		     see below
C
C		REPEAT CARDS 3 TO 4
C
C	    type of rxt 	   rxt format
C
C	       1	     aaaa+bbbb=cccc+dddd
C
C	       2	     aaaa+M=cccc+dddd+M
C
C	       3	     aaaa+bbbb+M=cccc+M
C
C	       4	     aaaa+bbbb=cccc+dddd+eeee
C
C	       5	     aaaa+M=bbbb+M
C
C	       6	     aaaa=bbbb+h*nu
C
C OUTPUT:
C
C      DERIV.INC...............MERGE IN DERIV
C      BDATA.INC...............MERGE IN BDATA
C      ENTHA.INC...............MERGE IN ENTHA
C      KDATA.DAT...............KINETIC DATA FILE
C
      CHARACTER*30 NA1,NA2,NA3,NA4,NA5,NA6
      CHARACTER*4 NAM(30),NAM1(20),IA1(5,100),IA(5),IR1,IR2,IR3
      CHARACTER*26 ISOURC(100)
      DIMENSION AK(30),XK(30),EK(30),
     1AAK(20),XXK(20),EEK(20),EN(6,30),EEN(6,20),IT(40),
     2K(40,5),L(40,20),M(20,40),M1(20),NU(30),W(30),
     3IT1(100),A(100),B(100),E(100),NDIR(100),NUR(40)
      LOGICAL LFL (20)
      itermin= 5
      ITERM= 6
      DO 2000 I=1,100
	 A(I)= 0.
	 B(I)= 0.
	 E(I)= 0.
	 NDIR(I)= 0
	 IT1(I)= 0
	 DO 1999 J= 1,5
	    IA1(J,I)= '    '
1999	 CONTINUE
2000  CONTINUE
      DO 2001 I=1,20
	 M1(I)= 0
	 AAK(I)= 0.
	 XXK(I)= 0.
	 EEK(I)= 0.
	 DO 2002 J=1,40
	    L(J,I)= 0
	    M(I,J)= 0
2002	  CONTINUE
	  DO 2003 J=1,6
	     EEN(J,I)= 0.0
2003	  CONTINUE
2001  CONTINUE
      DO 2005 I=1,30
	AK(I)= 0.
	XK(I)= 0.
	EK(I)= 0.
	NU(I)= 0
	W(I)= 0.
	DO 2006 J=1,6
	   EN(J,I)= 0.
2006	CONTINUE
2005  CONTINUE
      DO 2010 I=1,40
	 IT(I)= 0
	 NUR(I)= 0
	 DO 2009 J=1,5
	    K(I,J)= 0
2009	 CONTINUE
2010  CONTINUE
      WRITE(ITERM,459)
459   FORMAT('0','Program INTP : creates reaction system files')
      WRITE(ITERM,460)
460   FORMAT(' ')
      NA1= 'DABA.LIB'
      LI1 = 11
2011  CONTINUE
      OPEN(LI1,FILE = NA1,STATUS = 'OLD',IOSTAT=IER)
      IF (IER.EQ.0) GOTO 2012
      WRITE(ITERM,457) NA1
457   FORMAT(' ','Database ',A12,' not found')
461   WRITE(ITERM,454)
454   FORMAT(' ','Enter Reaction Library name: ')
      READ(ITERMin,451,ERR=461) NA1
451   FORMAT (A12)
      IF (NA1.EQ.' ') STOP
      GOTO 2011
2012  CONTINUE
462   WRITE(ITERM,456)
456   FORMAT(' ','Enter Reaction File Name (default = REAC.INP): ')
      READ (ITERMin,451,ERR=462) NA2
      IF (NA2.EQ.' ') NA2 = 'REAC.INP'
      LI2 = 12
      OPEN(LI2,FILE = NA2,STATUS = 'OLD',IOSTAT=IER)
      IF (IER.EQ.0) GOTO 2014
      WRITE(ITERM,458) NA2
458   FORMAT(' ','Input File ',A12,' not found')
      GOTO 2012
2014  CONTINUE
702   FORMAT (I2,1H,,I2,13H,1,89,1,1,0,0,/,5X,1HT,5X,1HT,5X,
     *1HT,/,24H0.1,0.01,2.,0.5,0.001,50,/,19(2H1,),1H1)
      READ (LI1,*) NAS
      DO 1 I=1,NAS
      READ (LI1,100) NAM(I)
100   FORMAT (A4)
      READ (LI1,*) AK(I),XK(I),EK(I),W(I)
      READ (LI1,*) (EN(J,I),J=1,6)
1     CONTINUE
      READ (LI1,*) NAR
      DO 23 I=1,NAR
      READ (LI1,*) IT1(I),A(I),B(I),E(I),NDIR(I)
      IF (IT1(I).NE.1) GO TO 24
      READ (LI1,1110) (IA1(J,I),J=1,4)
24    IF (IT1(I).NE.2) GO TO 25
      READ (LI1,1120) IA1(1,I),IA1(3,I),IA1(4,I)
25    IF (IT1(I).NE.3) GO TO 26
      READ (LI1,1130) (IA1(J,I),J=1,3)
26    IF (IT1(I).NE.4) GO TO 27
      READ (LI1,1150) (IA1(J,I),J=1,5)
27    IF (IT1(I).NE.5) GO TO 29
      READ (LI1,1160) (IA1(J,I), J=1,2)
29    IF (IT1(I).NE.6) GO TO 30
      READ (LI1,1170) (IA1(J,I), J=1,2)
30    CONTINUE
      READ (LI1,701) ISOURC(I)
23    CONTINUE
701   FORMAT (A26)
1110  FORMAT(A4,1X,A4,1X,A4,1X,A4)
1120  FORMAT(A4,3X,A4,1X,A4,2X)
1130  FORMAT(A4,1X,A4,3X,A4,2X)
1150  FORMAT(A4,1X,A4,1X,A4,1X,A4,1X,A4)
1160  FORMAT(A4,3X,A4,2X)
1170  FORMAT(A4,1X,A4,5X)
      NA6= 'KDATA.DAT'
      LO4 = 16
      OPEN(LO4,FILE = NA6,STATUS = 'UNKNOWN')
      NA3= 'DERIV.INC'
      LO1 = 13
      OPEN(LO1,FILE = NA3,STATUS = 'UNKNOWN')
      READ (LI2,1180) NS,NR
1180  FORMAT(I2,1X,I2)
      WRITE (LO4,702) NS,NR
      DO 7 I=1,NS
      READ (LI2,100) NAM1(I)
      WRITE (LO1,101) I,NAM1(I)
      DO 8 J1=1,NAS
      IF (NAM1(I).NE.NAM(J1)) GO TO 8
      NU(J1) = I
      GO TO 7
8     CONTINUE
      WRITE (ITERM,402)  NAM1(I)
402   FORMAT ('0','WARNING! ',A4,' IS NOT AVAILABLE',
     *' IN DATA BASE')
      GO TO 999
7     CONTINUE
      WRITE (LO1,140)
      DO 2 I=1,NR
      READ (LI2,*) IT(I)
      IF (IT(I).NE.1) GO TO 60
      READ (LI2,1110)(IA(J1),J1=1,4)
      DO 260 J=1,NAR
      IF (IT1(J).NE.1) GO TO 260
      IF((IA1(1,J).NE.IA(1)).AND.(IA1(1,J).NE.IA(2))) GOTO 261
      IF((IA1(1,J).EQ.IA(1)).AND.(IA1(2,J).NE.IA(2))) GOTO 261
      IF((IA1(1,J).EQ.IA(2)).AND.(IA1(2,J).NE.IA(1))) GOTO 261
      IF((IA1(3,J).NE.IA(3)).AND.(IA1(3,J).NE.IA(4))) GOTO 260
      IF((IA1(3,J).EQ.IA(3)).AND.(IA1(4,J).NE.IA(4))) GOTO 260
      IF((IA1(3,J).EQ.IA(4)).AND.(IA1(4,J).NE.IA(3))) GOTO 260
      NUR(I)=J
      IF(I.EQ.1) GOTO 1263
      DO 263 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR .NUR(I).EQ.0) GO TO 1263
      WRITE(ITERM,110)(IA(J1),J1=1,4)
      WRITE (ITERM,455)
455   FORMAT ('0',10X,'IS A DUPLICATED REACTION')
263   CONTINUE
1263  CONTINUE
      WRITE (LO4,700) I,NDIR(J),A(J),B(J),E(J)
      GO TO 262
261   IF((IA1(1,J).NE.IA(3)).AND.(IA1(1,J).NE.IA(4))) GOTO 260
      IF((IA1(1,J).EQ.IA(3)).AND.(IA1(2,J).NE.IA(4))) GOTO 260
      IF((IA1(1,J).EQ.IA(4)).AND.(IA1(2,J).NE.IA(3))) GOTO 260
      IF((IA1(3,J).NE.IA(1)).AND.(IA1(3,J).NE.IA(2))) GOTO 260
      IF((IA1(3,J).EQ.IA(1)).AND.(IA1(4,J).NE.IA(2))) GOTO 260
      IF((IA1(3,J).EQ.IA(2)).AND.(IA1(4,J).NE.IA(1))) GOTO 260
      IF (NDIR(J).EQ.1) ND     =2
      IF (NDIR(J).EQ.2) ND     =1
      NUR(I)=J
      IF (I.EQ.1) GO TO 1264
      DO 264 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR .NUR(I).EQ.0) GO TO 1264
      WRITE (ITERM,110)
     *(IA(J1),J1=1,4)
      WRITE (ITERM,455)
264   CONTINUE
1264  CONTINUE
      WRITE (LO4,700) I,ND     ,A(J),B(J),E(J)
      GO TO 262
260   CONTINUE
      WRITE (ITERM,452) I
452   FORMAT ('0','WARNING:Reaction#',I2,' IS UNKNOWN IN DATA BASE..')
262   CONTINUE
      WRITE(LO4,110) (IA(J1),J1=1,4)
      WRITE (LO1,111) I,(IA(J1),J1=1,4),NUR(I)
      DO 203 J2=1,20
      LFL(J2)=.TRUE.
203   CONTINUE
      DO 202 J1=1,4
      IF (J1.EQ.1.OR.J1.EQ.2) NSI=-1
      IF (J1.EQ.3.OR.J1.EQ.4) NSI=+1
      DO 201 J=1,NAS
      IF (IA(J1).NE.NAM(J)) GO TO 201
      IF (NU(J).EQ.0) WRITE (ITERM,453) NAM(J)
453   FORMAT ('0',10X,A4,' IS OMITTED IN INPUT FILE')
      K(I,J1) = NU(J)
      L(I,NU(J)) = NSI + L(I,NU(J))
      IF (.NOT.LFL(NU(J))) GO TO 201
      M1(NU(J)) = M1(NU(J)) + 1
      LFL(NU(J))=.FALSE.
      M(NU(J),M1(NU(J))) = I
201   CONTINUE
202   CONTINUE
      GO TO 64
60    IF (IT(I).NE.2) GO TO 61
      READ (LI2,1120) IA(1),IA(3),IA(4)
      DO 270 J=1,NAR
      IF(IT1(J).NE.2.AND.IT1(J).NE.3) GO TO 270
      IF (IT1(J).EQ.2) GO TO 274
      IR1=IA1(1,J)
      IR2=IA1(2,J)
      IR3=IA1(3,J)
      IA1(1,J)=IR3
      IA1(3,J)=IR1
      IA1(4,J)=IR2
      IT1(J)=2
      IF (NDIR(J).EQ.1) ND     =2
      IF (NDIR(J).EQ.2) ND     =1
      NDIR(J)=ND
274   CONTINUE
      IF(IA1(1,J).NE.IA(1)) GO TO 270
      IF((IA1(3,J).NE.IA(3)).AND.(IA1(3,J).NE.IA(4))) GOTO 270
      IF((IA1(3,J).EQ.IA(3)).AND.(IA1(4,J).NE.IA(4))) GOTO 270
      IF((IA1(4,J).EQ.IA(3)).AND.(IA1(3,J).NE.IA(4))) GOTO 270
      NUR(I)=J
      IF (I.EQ.1) GO TO 1275
      DO 275 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR .NUR(I).EQ.0) GO TO 1275
      WRITE (ITERM,120)
     *IA(1),IA(3),IA(4)
      WRITE (ITERM,455)
275   CONTINUE
1275  CONTINUE
      WRITE (LO4,700) I,NDIR(J),A(J),B(J),E(J)
      GO TO 272
270   CONTINUE
      WRITE (ITERM,452) I
272   CONTINUE
      WRITE(LO4,120) IA(1),IA(3),IA(4)
      WRITE (LO1,121) I,IA(1),IA(3),IA(4),NUR(I)
      DO 213 J2=1,20
      LFL(J2)=.TRUE.
213   CONTINUE
      DO 212 J1=1,4
      IF (J1.EQ.2) GO TO 212
      IF (J1.EQ.1) NSI=-1
      IF (J1.EQ.3.OR.J1.EQ.4) NSI=+1
      DO 211 J=1,NAS
      IF (IA(J1).NE.NAM(J)) GO TO 211
      IF (NU(J).EQ.0) WRITE (ITERM,453) NAM(J)
      K(I,J1) = NU(J)
      L(I,NU(J)) = NSI + L(I,NU(J))
      IF (.NOT.LFL(NU(J))) GO TO 211
      M1(NU(J)) = M1(NU(J)) + 1
      LFL(NU(J))=.FALSE.
      M(NU(J),M1(NU(J))) = I
211   CONTINUE
212   CONTINUE
      GO TO 64
61    IF (IT(I).NE.3) GO TO 62
      READ (LI2,1130) IA(1),IA(2),IA(3)
      DO 280 J=1,NAR
      IF (IT1(J).NE.3.AND.IT1(J).NE.2) GO TO 280
      IF (IT1(J).EQ.3) GO TO 284
      IR1=IA1(1,J)
      IR2=IA1(3,J)
      IR3=IA1(4,J)
      IA1(1,J)=IR2
      IA1(2,J)=IR3
      IA1(3,J)=IR1
      IT1(J)=3
      IF (NDIR(J).EQ.1) ND     =2
      IF (NDIR(J).EQ.2) ND     =1
      NDIR(J)=ND
284   CONTINUE
      IF(IA1(3,J).NE.IA(3)) GO TO 280
      IF((IA1(1,J).NE.IA(1)).AND.(IA1(1,J).NE.IA(2))) GOTO 280
      IF((IA1(1,J).EQ.IA(1)).AND.(IA1(2,J).NE.IA(2))) GOTO 280
      IF((IA1(1,J).EQ.IA(2)).AND.(IA1(2,J).NE.IA(1))) GOTO 280
      NUR(I)=J
      IF (I.EQ.1) GO TO 1285
      DO 285 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR.NUR(I).EQ.0) GO TO 1285
      WRITE (ITERM,130) (IA(J1),J1=1,3)
      WRITE (ITERM,455)
285   CONTINUE
1285  CONTINUE
      WRITE (LO4,700) I,NDIR(J),A(J),B(J),E(J)
      GO TO 282
280   CONTINUE
      WRITE (ITERM,452) I
282   CONTINUE
      WRITE(LO4,130) (IA(J1),J1=1,3)
      WRITE (LO1,131) I,IA(1),IA(2),IA(3),NUR(I)
      DO 223 J2=1,20
      LFL(J2)=.TRUE.
223   CONTINUE
      DO 222 J1=1,4
      IF (J1.EQ.4) GO TO 222
      IF (J1.EQ.1.OR.J1.EQ.2) NSI=-1
      IF (J1.EQ.3) NSI=+1
      DO 221 J=1,NAS
      IF (IA(J1).NE.NAM(J)) GO TO 221
      IF (NU(J).EQ.0) WRITE (ITERM,453) NAM(J)
      K(I,J1) = NU(J)
      L(I,NU(J)) = NSI + L(I,NU(J))
      IF (.NOT.LFL(NU(J))) GO TO 221
      M1(NU(J)) =M1(NU(J)) + 1
      LFL(NU(J))=.FALSE.
      M(NU(J),M1(NU(J))) = I
221   CONTINUE
222   CONTINUE
      GO TO 64
62    IF (IT(I).NE.4) GO TO 63
      READ (LI2,1150) (IA(J1),J1=1,5)
      DO 290 J=1,NAR
      IF (IT1(J).NE.4) GO TO 290
      IF((IA1(1,J).NE.IA(1)).AND.(IA1(1,J).NE.IA(2))) GOTO 290
      IF((IA1(1,J).EQ.IA(1)).AND.(IA1(2,J).NE.IA(2))) GOTO 290
      IF((IA1(1,J).EQ.IA(2)).AND.(IA1(2,J).NE.IA(1))) GOTO 290
C
C
C  PLEASE INPUT THE RIGHT HAND SIDE OF TERMOLECULAR REACTIONS IN
C  ALPHANUMERICAL ORDER OF THE SPECIES NAME.
C
C	EXAMPLE:  H2  +O2  =H	+O   +OH
C
C	  INSTEAD OF:  H2  +O2	=O   +H   +OH
C
C
      IF (IA1(3,J).NE.IA(3)) GO TO 290
      IF (IA1(4,J).NE.IA(4)) GO TO 290
      IF (IA1(5,J).NE.IA(5)) GO TO 290
      NUR(I)=J
      IF (I.EQ.1) GO TO 1295
      DO 295 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR.NUR(I).EQ.0) GO TO 1295
      WRITE (ITERM,150) (IA(J1),J1=1,5)
      WRITE (ITERM,455)
295   CONTINUE
1295  CONTINUE
      WRITE (LO4,700) I,NDIR(J),A(J),B(J),E(J)
      GO TO 292
290   CONTINUE
      WRITE (ITERM,452) I
292   CONTINUE
      WRITE(LO4,150) (IA(J1),J1=1,5)
      WRITE (LO1,141) I, (IA(J1),J1=1,5) ,NUR(I)
      DO 233 J2=1,20
      LFL(J2) =.TRUE.
233   CONTINUE
      DO 232 J1=1,5
      IF (J1.EQ.1.OR.J1.EQ.2) NSI =-1
      IF (J1.EQ.3.OR.J1.EQ.4.OR.J1.EQ.5) NSI=+1
      DO 231 J=1,NAS
      IF (IA(J1).NE.NAM(J)) GO TO 231
      IF (NU(J).EQ.0) WRITE (ITERM,453) NAM(J)
      K(I,J1) =NU(J)
      L(I,NU(J))=NSI+L(I,NU(J))
      IF (.NOT.LFL(NU(J))) GO TO 231
      M1(NU(J)) = M1(NU(J))+1
      LFL(NU(J))=.FALSE.
      M(NU(J),M1(NU(J))) = I
231   CONTINUE
232   CONTINUE
      GO TO 64
63    IF(IT(I).NE.5) GO TO 65
      READ (LI2,1160) (IA(J1), J1=1,2)
      DO 291 J=1,NAR
      ND=0
      IF (IT1(J).NE.5) GO TO 291
      IF ((IA1(1,J).NE.IA(1)).AND.(IA1(2,J).NE.IA(1))) GOTO 291
      IF ((IA1(1,J).EQ.IA(1)).AND.(IA1(2,J).EQ.IA(2))) ND=1
      IF ((IA1(1,J).EQ.IA(2)).AND.(IA1(2,J).EQ.IA(1))) ND=2
      IF (ND.EQ.0) GO TO 291
      NUR(I)=J
      IF (I.EQ.1) GO TO 1293
      DO 293 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR.NUR(I).EQ.0) GO TO 1293
      WRITE (ITERM,160) IA(1),IA(2)
      WRITE (ITERM,455)
293   CONTINUE
1293  CONTINUE
      IF (ND.EQ.1.AND.NDIR(J).EQ.1) NDD=1
      IF (ND.EQ.1.AND.NDIR(J).EQ.2) NDD=2
      IF (ND.EQ.2.AND.NDIR(J).EQ.1) NDD=2
      IF (ND.EQ.2.AND.NDIR(J).EQ.2) NDD=1
      WRITE (LO4,700) I,NDD,A(J),B(J),E(J)
      GO TO 294
291   CONTINUE
      WRITE (ITERM,452) I
294   CONTINUE
      WRITE(LO4,160) IA(1),IA(2)
      WRITE (LO1,161) I,IA(1),IA(2),NUR(I)
      DO 243 J2=1,20
      LFL(J2)=.TRUE.
243   CONTINUE
      DO 242 J1=1,2
      IF (J1.EQ.1) NSI=-1
      IF (J1.EQ.2) NSI=+1
      DO 241 J=1,NAS
      IF (IA(J1).NE.NAM(J)) GO TO 241
      IF (NU(J).EQ.0) WRITE (ITERM,453) NAM(J)
      K(I,J1)=NU(J)
      L(I,NU(J))=NSI+L(I,NU(J))
      IF (.NOT.LFL(NU(J))) GO TO 241
      M1(NU(J))=M1(NU(J))+1
      LFL(NU(J))=.FALSE.
      M(NU(J),M1(NU(J)))=I
241   CONTINUE
242   CONTINUE
      GO TO 64
65    IF (IT(I).NE.6) GO TO 66
      READ (LI2,1170) (IA(J1),J1=1,2)
      DO 801 J=1,NAR
      IF (IT1(J).NE.6) GO TO 801
      IF ((IA1(1,J).NE.IA(1)).AND.(IA1(2,J).NE.IA(2))) GOTO 801
      NUR(I)=J
      IF (I.EQ.1) GO TO 1802
      DO 802 J4=1,I-1
      IF (NUR(I).NE.NUR(J4).OR.NUR(I).EQ.0) GO TO 1802
      WRITE (ITERM,170) IA(1),IA(2)
      WRITE (ITERM,455)
802   CONTINUE
1802  CONTINUE
      ND=1
      WRITE (LO4,700) I,ND,A(J),B(J),E(J)
      GO TO 803
801   CONTINUE
      WRITE (ITERM,452) I
803   CONTINUE
      WRITE(LO4,170) IA(1),IA(2)
      WRITE (LO1,171) I,IA(1),IA(2),NUR(I)
      DO 253 J2=1,20
      LFL(J2)=.TRUE.
253   CONTINUE
      DO 252 J1=1,2
      IF (J1.EQ.1) NSI=-1
      IF (J1.EQ.2) NSI= 0
      DO 251 J=1,NAS
      IF (IA(J1).NE.NAM(J)) GO TO 251
      IF (NU(J).EQ.0) WRITE (ITERM,453) NAM(J)
      K(I,J1)=NU(J)
      L(I,NU(J))=NSI+L(I,NU(J))
      IF (.NOT.LFL(NU(J))) GO TO 251
      M1(NU(J))=M1(NU(J))+1
      LFL(NU(J))=.FALSE.
      M(NU(J),M1(NU(J)))=I
251   CONTINUE
252   CONTINUE
      GO TO 64
66    WRITE (ITERM,400) I
400   FORMAT ('0','RXT #',I2,' :TYPE IS UNKNOWN',////)
      GO TO 999
64    CONTINUE
      WRITE(LO4,701) ISOURC(NUR(I))
110   FORMAT (' ',A4,1H+,A4,1H=,A4,1H+,A4,5X)
120   FORMAT (' ',A4,3H+M=,A4,1H+,A4,2H+M,6X)
130   FORMAT (' ',A4,1H+,A4,3H+M=,A4,2H+M,6X)
150   FORMAT (' ',A4,1H+,A4,1H=,2(A4,1H+),A4)
160   FORMAT (' ',A4,3H+M=,A4,2H+M,11X)
170   FORMAT (' ',A4,1H=,A4,5H+h*nu,10X)
2     CONTINUE
      CLOSE(LO4,STATUS = 'KEEP')
      I3=60-NS-NR
      IF (I3.LE.0) GO TO 1022
      DO 22 I1=1,I3
C     WRITE (LO1,319)
22    CONTINUE
1022  CONTINUE
101   FORMAT (1HC,10X,2HX(,I2,1H),17X,A4)
111   FORMAT (1HC,7X,I2,10X,A4,1H+,A4,1H=,A4,1H+,A4,10X,I3)
121   FORMAT (1HC,7X,I2,10X,A4,3H+M=,A4,1H+,A4,2H+M,11X,I3)
131   FORMAT (1HC,7X,I2,10X,A4,1H+,A4,3H+M=,A4,2H+M,11X,I3)
141   FORMAT (1HC,7X,I2,10X,A4,1H+,A4,1H=,2(A4,1H+),A4,5X,I3)
161   FORMAT (1HC,7X,I2,10X,A4,2H+M,3X,1H=,A4,2H+M,13X,I3)
171   FORMAT (1HC,7X,I2,10X,A4,5X,1H=,A4,5H+h*nu,10X,I3)
140   FORMAT (2
     *(1HC,/),1HC,6X,'THE FOLLOWING REACTIONS ARE PRESENTLY INCORPO',
     *'RATED:',/,1HC,/,1HC,6X,6HNUMBER,18X,8HREACTION,10X,'LIBRARY #',
     */,1HC,5X,70(1H-),/,1HC,/,1HC)
700   FORMAT (I2,1H,,I1,1H,,2(E12.6,1H,),E12.6)
      DO 3 I=1,NR
      IF (IT(I).NE.1) GO TO 70
      WRITE (LO1,300) I,I,K(I,1),K(I,2)
      WRITE (LO1,301) I,I,K(I,3),K(I,4)
      GO TO 3
70    IF (IT(I).NE.2) GO TO 71
      WRITE (LO1,302) I,I,K(I,1)
      WRITE (LO1,303) I,I,K(I,3),K(I,4)
      GO TO 3
71    IF (IT(I).NE.3) GO TO 72
      WRITE (LO1,304) I,I,K(I,1),K(I,2)
      WRITE (LO1,305) I,I,K(I,3)
      GO TO 3
72    IF (IT(I).NE.4) GO TO 73
      WRITE (LO1,300) I,I,K(I,1),K(I,2)
      WRITE (LO1,320) I,I,K(I,3),K(I,4),K(I,5)
      GO TO 3
73    IF (IT(I).NE.5) GO TO 74
      WRITE (LO1,302) I,I,K(I,1)
      WRITE (LO1,305) I,I,K(I,2)
      GO TO 3
74    CONTINUE
      WRITE (LO1,806) I,I,K(I,1)
      WRITE (LO1,319)
3     CONTINUE
      WRITE(LO1,318)
      NL=0
      DO 4 I=1,NS
      N=0
5     N=N+1
      NI=(N-1)*4+1
      NK=M1(I)-NI+1
      NM=N*4
      IF (M1(I).GT.NM.OR.N.NE.1) GO TO 80
      IF (NK.EQ.1) WRITE (LO1,306) I,L(M(I,1),I),M(I,1)
      IF (NK.EQ.2) WRITE (LO1,307) I,(L(M(I,J),I),M(I,J),J=1,2)
      IF (NK.EQ.3) WRITE (LO1,308) I,(L(M(I,J),I),M(I,J),J=1,3)
      IF (NK.EQ.4) WRITE (LO1,309) I,(L(M(I,J),I),M(I,J),J=1,4)
      NL=NL+1
      GO TO 4
80    IF (M1(I).GT.NM.OR.N.EQ.1) GO TO 81
      IF (NK.EQ.1) WRITE (LO1,311) L(M(I,NI),I),M(I,NI)
      IF (NK.EQ.2) WRITE (LO1,312) (L(M(I,J),I),M(I,J),J=NI,NI+1)
      IF (NK.EQ.3) WRITE (LO1,313) (L(M(I,J),I),M(I,J),J=NI,NI+2)
      IF (NK.EQ.4) WRITE (LO1,314) (L(M(I,J),I),M(I,J),J=NI,NI+3)
      NL=NL+1
      GO TO 4
81    IF (M1(I).LE.NM.OR.N.NE.1) GO TO 82
      WRITE(LO1,316)I,(L(M(I,J),I),M(I,J),J=NI,NI+3)
      NL=NL+1
      GO TO 5
82    WRITE (LO1,317) (L(M(I,J),I),M(I,J),J=NI,NI+3)
      NL=NL+1
      GO TO 5
4     CONTINUE
      CLOSE(LO1,STATUS = 'KEEP')
300   FORMAT (6X,3HRF(,I2,4H)=R(,I2,6H,1)*X(,I2,4H)*X(,I2,1H))
301   FORMAT (6X,3HRB(,I2,4H)=R(,I2,6H,2)*X(,I2,4H)*X(,I2,1H))
302   FORMAT (6X,3HRF(,I2,4H)=R(,I2,6H,1)*X(,I2,4H)*XM)
303   FORMAT (6X,3HRB(,I2,4H)=R(,I2,6H,2)*X(,I2,4H)*X(,I2,4H)*XM)
304   FORMAT (6X,3HRF(,I2,4H)=R(,I2,6H,1)*X(,I2,4H)*X(,I2,4H)*XM)
305   FORMAT (6X,3HRB(,I2,4H)=R(,I2,6H,2)*X(,I2,4H)*XM)
320   FORMAT (6X,3HRB(,I2,4H)=R(,I2,6H,2)*X(,2(I2,4H)*X(),I2,1H))
806   FORMAT (6X,3HRF(,I2,4H)=R(,I2,6H,1)*X(,I2,1H))
318   FORMAT (6X,14HDO 1 I=1,NREAC,/,6X,
     *17HRP(I)=RF(I)-RB(I),/,1H1,5X,8HCONTINUE)
306   FORMAT (6X,2HF(,I2,3H)=(,1(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
307   FORMAT (6X,2HF(,I2,3H)=(,2(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
308   FORMAT (6X,2HF(,I2,3H)=(,3(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
309   FORMAT (6X,2HF(,I2,3H)=(,4(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
316   FORMAT (6X,2HF(,I2,3H)=(,4(1H(,I2,5H)*RP(,I2,2H)+))
317   FORMAT (5X,1H*,4(1H(,I2,5H)*RP(,I2,2H)+))
311   FORMAT (5X,1H*,1(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
312   FORMAT (5X,1H*,2(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
313   FORMAT (5X,1H*,3(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
314   FORMAT (5X,1H*,4(1H(,I2,5H)*RP(,I2,2H)+),4H0)*H)
      NL=140-3-NL-2*NR
      IF (NL.GT.0) GO TO 90
      NL=140-NL
      WRITE (ITERM,401) NL
401   FORMAT ('0','WARNING:# OF PRGM LINES FOR DERIV=',I3)
      GO TO 91
90    DO 6 I=1,NL
C     WRITE (LO1,319)
319   FORMAT (1HC)
6     CONTINUE
91    CONTINUE
      NA4 = 'BDATA.INC'
      LO2 = 14
      OPEN(LO2,FILE = NA4,STATUS = 'UNKNOWN')
      WRITE (LO2,500)
500   FORMAT (6X,10HDATA AAKP/)
      DO 9 I=1,NAS
      IF (NU(I).LE.0) GO TO 9
      AAK(NU(I))=AK(I)
      XXK(NU(I))=XK(I)
      EEK(NU(I))=EK(I)
      DO 17 J=1,6
      EEN(J,NU(I))=EN(J,I)
17    CONTINUE
9     CONTINUE
      DO 10 I=1,3
      NI=(I-1)*5+1
      NM=NI+4
      WRITE (LO2,501) (AAK(J),J=NI,NM)
10    CONTINUE
      WRITE (LO2,502) (AAK(J),J=16,20)
501   FORMAT (5X,1H*,5(E11.4,1H,))
502   FORMAT (5X,1H*,4(E11.4,1H,),E11.4,1H/)
503   FORMAT (6X,11HDATA XXNKP/)
      WRITE (LO2,503)
      DO 11 I=1,3
      NI=(I-1)*5+1
      NM=NI+4
      WRITE (LO2,501) (XXK(J),J=NI,NM)
11    CONTINUE
      WRITE (LO2,502) (XXK(J),J=16,20)
      WRITE (LO2,504)
504   FORMAT (6X,10HDATA EEKP/)
      DO 12 I=1,3
      NI=(I-1)*5+1
      NM=NI+4
      WRITE (LO2,501) (EEK(J),J=NI,NM)
12    CONTINUE
      WRITE (LO2,502) (EEK(J),J=16,20)
      WRITE (LO2,505)
505   FORMAT (6X,11HDATA NNAME/)
      NS1=NS+1
      IF (NS1.GT.20) GO TO 1013
      DO 13 I5=NS1,20
      NAM1(I5)='    '
13    CONTINUE
1013  CONTINUE
      DO 14 I=1,3
      NI=(I-1)*5+1
      NM=NI+4
      WRITE (LO2,506) (NAM1(J),J=NI,NM)
14    CONTINUE
      WRITE (LO2,507) (NAM1(J),J=16,20)
506   FORMAT (5X,1H*,5(1H',A4,2H',))
507   FORMAT (5X,1H*, 4(1H',A4,2H',),1H',A4,2H'/)
      DO 15 I1=1,4
      WRITE (LO2,508) I1
508   FORMAT (6X,'DATA ((NUUN',I1,'(j,i),j=1,20),i=1,5)/')
      NI=(I1-1)*10+1
      NM=NI+9
      DO 16 I=NI,NM-6
      WRITE (LO2,509) (L(I,J),J=1,20)
509   FORMAT (5X,1H*,20(I2,1H,))
16    CONTINUE
      WRITE (LO2,510) (L(NM-5,J),J=1,20)
510   FORMAT (5X,1H*,19(I2,1H,),I2,1H/)
      WRITE (LO2,1508) I1
1508  FORMAT (6X,'DATA ((NUUN',I1,'(j,i),j=1,20),i=6,10)/')
      NI=(I1-1)*10+1
      NM=NI+9
      DO 1016 I=NI+5,NM-1
      WRITE (LO2,509) (L(I,J),J=1,20)
1016  CONTINUE
      WRITE (LO2,510) (L(NM,J),J=1,20)
15    CONTINUE
      CLOSE(LO2,STATUS = 'KEEP')
      NA5 = 'ENTHA.INC'
      LO3 = 15
      OPEN(LO3,FILE = NA5,STATUS = 'UNKNOWN')
      WRITE (LO3,600)
600   FORMAT (6X,'DATA ((AEN(j,i),j=1,20),i=1,3)/')
      DO 18 I=1,3
      DO 18 J1=1,4
      NI=(J1-1)*5+1
      NM=NI+4
      IF (I.NE.3.OR.J1.NE.4) WRITE (LO3,601) (EEN(I,J),J=NI,NM)
601   FORMAT (5X,1H*,5(E11.5,1H,))
18    CONTINUE
      WRITE (LO3,602) (EEN(3,J),J=16,20)
      WRITE (LO3,1600)
1600  FORMAT (6X,'DATA ((AEN(j,i),j=1,20),i=4,6)/')
      DO 1018 I=4,6
      DO 1018 J1=1,4
      NI=(J1-1)*5+1
      NM=NI+4
      IF (I.NE.6.OR.J1.NE.4) WRITE (LO3,601) (EEN(I,J),J=NI,NM)
1018  CONTINUE
      WRITE (LO3,602) (EEN(6,J),J=16,20)
602   FORMAT (5X,1H*,4(E11.5,1H,),E11.5,1H/)
      DO 20 I=1,NAS
      IF (NU(I).LE.0) GO TO 20
      WRITE (LO3,603) NU(I),W(I)
20    CONTINUE
603   FORMAT (6X,2HW(,I2,2H)=,F6.2)
      WRITE (LO3,604)
604   FORMAT (6X,9HW(21)=40.)
      NL=20-NS
      IF (NL.LE.0) GO TO 1021
      DO 21 I=1,NL
C     WRITE (LO3,319)
21    CONTINUE
1021  CONTINUE
      CLOSE(LO3,STATUS = 'KEEP')
999   CLOSE(LI1,STATUS = 'KEEP')
      CLOSE(LI2,STATUS = 'KEEP')
      STOP
      END

